QT       += core gui dbus dtkwidget svg concurrent

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

TARGET = deepin-offline-update-tool
TEMPLATE = app
CONFIG += c++11 link_pkgconfig
CONFIG += console
PKGCONFIG += gsettings-qt dframeworkdbus gio-unix-2.0

INCLUDEPATH += src
include($$PWD/src/window/modules/modules.pri)

isEmpty(VERSION) {
    VERSION = 1.0.0
}
DEFINES += QMAKE_TARGET=\\\"$$TARGET\\\" QMAKE_VERSION=\\\"$$VERSION\\\"

SOURCES += \
        src/main.cpp \
        src/defenderdbusservice.cpp \
        src/window/mainwindow.cpp \
        src/window/interface/moduleinterface.cpp \
        src/widgets/multiselectlistview.cpp \
        src/widgets/defendertableheaderview.cpp \
    src/widgets/upgradewidget.cpp

HEADERS += \
        src/window/mainwindow.h \
        src/defenderdbusservice.h \
        src/window/interface/frameproxyinterface.h \
        src/window/interface/moduleinterface.h \
        src/widgets/multiselectlistview.h \
        src/widgets/defendertableheaderview.h \
    src/widgets/upgradewidget.h

isEmpty(PREFIX){
    PREFIX = /usr
}

# 删除所有的生成的qm文件
system(rm $$PWD/translations/*.qm)
CONFIG(release, debug|release) {
    message("current dir:" + $$PWD)
    TRANSLATIONS = $$files($$PWD/translations/*.ts)
    #遍历目录中的ts文件，调用lrelease将其生成为qm文件
    for(tsfile, TRANSLATIONS) {
       qmfile = $$replace(tsfile, .ts$, .qm)
       system(lrelease $$tsfile -qm $$qmfile) | error("Failed to lrelease")
    }
    #将qm文件添加到安装包
    dtk_translations.path = /usr/share/$$TARGET/translations
    dtk_translations.files = $$PWD/translations/*.qm
    INSTALLS += dtk_translations
}

# 界面dbus接口相关文件
upgradedbus.files = com.deepin.offline.update.tool.xml
DBUS_ADAPTORS += upgradedbus
DBUS_INTERFACES += upgradedbus

# 服务安装路径
target.path = $${PREFIX}/bin/

# 翻译qm
install_qm.files = ./translations/*.qm
install_qm.path = $${PREFIX}/share/deepin-offline-update-tool/translations

# dekstop安装路径
install_desktop.files = ./deepin-offline-update-tool.desktop
install_desktop.path = $${PREFIX}/share/applications

# mimetype安装路径
install_mimetype.files = ./deepin-offline-update.xml
install_mimetype.path = $${PREFIX}/share/mime/packages

# 系统升级工具图片安装路径
icon.path = /usr/share/icons/hicolor/scalable/apps
icon.files = $$PWD/src/window/icons/icons/upgrade-tool.svg

# backup安装路径
install_backup.files = ./backup.yaml
install_backup.path = /etc/deepin-offline-update/

# update.list安装路径
install_update.files = ./update.list
install_update.path = /etc/deepin-offline-update/

# tool客户端服务安装路径
install_service.files = ./com.deepin.offline.update.tool.service
install_service.path = $${PREFIX}/share/dbus-1/services

# gsetting配置安装路径
install_gsettings.files = ./schemas/*.gschema.xml
install_gsettings.path = $${PREFIX}/share/glib-2.0/schemas/

# 安装文件到某个路径
INSTALLS += target install_qm install_desktop install_mimetype icon install_backup install_update install_service install_gsettings

RESOURCES += \
    src/window/icons/defender_icons.qrc
