/*
 * Copyright (C) 2023 ~ 2024 UnionTech Software Technology Co., Ltd.
 *
 * Author:     caimengci <caimengci@uniontech.com>
 *
 * Maintainer: caimengci <caimengci@uniontech.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

class QWidget;
class QString;

class ModuleInterface;
class FrameProxyInterface
{
public:
    // Module request to into next page
    // 推窗口进显示栈
    virtual void pushWidget(ModuleInterface *const inter, QWidget *const w) = 0;
    // 将窗口出显示栈
    virtual void popWidget(ModuleInterface *const inter) = 0;
    // 将窗口出显示栈, 并删除
    virtual void popAndDelWidget(ModuleInterface *const inter) = 0;
    // 设置模块可见
    virtual void setModuleVisible(ModuleInterface *const inter, const bool visible) = 0;
    // 设置当前显示模块
    virtual void setCurrentModule(int iModuleIdx, int iPageIdx) = 0;
    // 获取当前显示栈的索引
    virtual ModuleInterface *getCurrentModule() = 0;
    // 通过模块名称获取模块索引
    virtual int getModuleIndex(const QString &name) = 0;
};
