/*
 * Copyright (C) 2017 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     luokai <luokai_cm@deepin.com>
 *
 * Maintainer: luokai <luokai_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include "invokers/invokerfactory.h"

#include <DSysInfo>

#include <QMap>
#include <QIcon>

DCORE_USE_NAMESPACE

// 离线包检测项
enum OfflineCheckItem {
    OfflineFileArXSpace = 0, // 离线包解压空间
    OfflineFileDirComplete, // 离线包目录结构完整性
    HooksPre, // 安装前置检测
    SystemVersion, // 系统版本 -专业版/服务器版
    OfflineFileArch, // 离线包架构 -amd/arm/mips/loongarch/sw
    SystemBackupSpace, // 系统备份空间
    UpgradeSum, // 更新包数量
    CancelUpdate, // 取消升级
};

enum UpgradeType {
    SystemUpgrade = 1, // 系统更新
    CVEPatchUpgrade, // cve补丁更新
};

#define ARCH_AMD "x86_64" // AMD平台
#define ARCH_ARM "aarch64" // ARM平台
#define ARCH_MIPS "mips64" // MIPS平台
#define ARCH_SW "sw_64" // SW平台
#define ARCH_LOONGARCH "loongarch64" // LOONGARCH平台

// 主窗口对象名称
#define MAIN_WINDOW_OBJ_NAME "mainWindow"

// 公共dbus接口类
#define DBUS_PROPERTY_INVOKER_NAME "dbusPropertyInvoker" // 公共dbus接口属性获取识别

// 模块名
#define MODULE_OFFLINEUPDATE_NAME "offlineupdate" // 离线更新
#define MODULE_SYSTEMUPDATE_NAME "systemupdate" // 系统更新

// gsettings字段
#define NAV_SHOW_TYPE "nav-show-type" // 导航栏是否显示

namespace Utils {
// 检查并转换QDbusVariant为QVariant
QVariant checkAndTransQDbusVarIntoQVar(const QVariant &var);
} // namespace Utils
