/*
 * Copyright (C) 2020 ~ 2020 Deepin Technology Co., Ltd.
 *
 * Author:     caimengci <caimengci@uniontech.com>
 *
 * Maintainer: caimengci <caimengci@uniontech.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "isoupdatemodule.h"
#include "isoupdatewidget.h"
#include "isoupdatemodel.h"

#include <QModelIndex>
#include <QStandardItemModel>

ISOUpdateModule::ISOUpdateModule(FrameProxyInterface *frame, QObject *parent)
    : QObject(parent)
    , ModuleInterface(frame)
    , m_isoUpdateWidget(nullptr)
    , m_isoUpdateModel(nullptr)
{
}

ISOUpdateModule::~ISOUpdateModule()
{
    deactive();
}

void ISOUpdateModule::initialize()
{
}

void ISOUpdateModule::preInitialize()
{
}

const QString ISOUpdateModule::name() const
{
    return "isoupdate";
}

void ISOUpdateModule::active(int index)
{
    Q_UNUSED(index)

    if (!m_isoUpdateModel) {
        m_isoUpdateModel = new ISOUpdateModel(this);
    }
    m_isoUpdateWidget = new ISOUpdateWidget(m_isoUpdateModel);
    m_isoUpdateWidget->show();

    m_frameProxy->pushWidget(this, m_isoUpdateWidget);
}

void ISOUpdateModule::deactive()
{
    if (nullptr != m_isoUpdateWidget) {
        m_isoUpdateWidget->deleteLater();
        m_isoUpdateWidget = nullptr;
    }
}
