/*
 * Copyright (C) 2023 ~ 2024 UnionTech Software Technology Co., Ltd.
 *
 * Author:     caimengci <caimengci@uniontech.com>
 *
 * Maintainer: caimengci <caimengci@uniontech.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include "window/interface/moduleinterface.h"

class ModuleInterface;
class FrameProxyInterface;
class ISOUpdateWidget;
class ISOUpdateModel;

class ISOUpdateModule : public QObject
    , public ModuleInterface
{
    Q_OBJECT
public:
    explicit ISOUpdateModule(FrameProxyInterface *frame, QObject *parent = nullptr);
    ~ISOUpdateModule() override;

public:
    void initialize() override;
    void preInitialize() override;
    const QString name() const override;
    void active(int index) override;
    void deactive() override;

private:
    ISOUpdateWidget *m_isoUpdateWidget;
    ISOUpdateModel *m_isoUpdateModel;
};
