/*
 * Copyright (C) 2023 ~ 2024 UnionTech Software Technology Co., Ltd.
 *
 * Author:     caimengci <caimengci@uniontech.com>
 *
 * Maintainer: caimengci <caimengci@uniontech.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once
#include <DDialog>
#include <DWidget>
#include <DBlurEffectWidget>
#include <DWarningButton>

DWIDGET_USE_NAMESPACE
class ConfirmDialog : public DDialog
{
    Q_OBJECT
public:
    explicit ConfirmDialog(bool status, QWidget *parent = nullptr);
    ~ConfirmDialog();

private Q_SLOTS:
    // 选择框的改变
    void checkBoxChange(int status);

Q_SIGNALS:
    void sendStartUpgrade();

private:
    bool m_status;
    DCheckBox *m_checkBox;
    QPushButton *m_cancelBtn;
    DWarningButton *m_okBtn;
};
