/*
 * Copyright (C) 2023 ~ 2024 UnionTech Software Technology Co., Ltd.
 *
 * Author:     caimengci <caimengci@uniontech.com>
 *
 * Maintainer: caimengci <caimengci@uniontech.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include <DWidget>
#include <DFrame>
#include <DSuggestButton>
#include <DLabel>
#include <DSpinner>

class QStandardItemModel;
class OfflineUpdateModel;

DWIDGET_USE_NAMESPACE
class OfflineUpdateCheckingWidget : public QWidget
{
    Q_OBJECT

public:
    explicit OfflineUpdateCheckingWidget(OfflineUpdateModel *model, DWidget *parent = nullptr);
    ~OfflineUpdateCheckingWidget();

    // 停止等待
    void stopWaiting();

private:
    // 初始化
    void initUI();
    void initData();

private:
    OfflineUpdateModel *m_model;

    //等待界面
    DSpinner *m_waitSpinner;
    DLabel *m_waitingLabel;
};
