/*
 * Copyright (C) 2023 ~ 2024 UnionTech Software Technology Co., Ltd.
 *
 * Author:     caimengci <caimengci@uniontech.com>
 *
 * Maintainer: caimengci <caimengci@uniontech.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include "window/interface/moduleinterface.h"

class ModuleInterface;
class FrameProxyInterface;
class OfflineUpdateWidget;
class OfflineUpdateCheckingWidget;
class OfflineCheckResultWidget;
class OfflineUpdateModel;

class OfflineUpdateModule : public QObject
    , public ModuleInterface
{
    Q_OBJECT
public:
    explicit OfflineUpdateModule(FrameProxyInterface *frame, QObject *parent = nullptr);
    ~OfflineUpdateModule() override;

    void initialize() override;
    void preInitialize() override;
    const QString name() const override;
    void active(int index) override;
    void deactive() override;

    void setOfflineUpdateFile(QString filepath);

public Q_SLOTS:
    void acceptCheckFilePath(QString filepath);
    void acceptOfflineCheckResult(int itemType, bool result);

Q_SIGNALS:
    void sendToolExit();

private:
    OfflineUpdateWidget *m_offlineUpdateWidget;
    OfflineUpdateCheckingWidget *m_offlineUpdateCheckingWidget;
    OfflineCheckResultWidget *m_offlineCheckResultWidget;
    OfflineUpdateModel *m_offlineUpdateModel;
};
