/*
 * Copyright (C) 2023 ~ 2024 UnionTech Software Technology Co., Ltd.
 *
 * Author:     caimengci <caimengci@uniontech.com>
 *
 * Maintainer: caimengci <caimengci@uniontech.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include <DWidget>
#include <DFrame>
#include <DSuggestButton>
#include <DLabel>

class QStandardItemModel;
class OfflineUpdateModel;

DWIDGET_USE_NAMESPACE
class OfflineUpdateWidget : public QWidget
{
    Q_OBJECT

public:
    explicit OfflineUpdateWidget(OfflineUpdateModel *model, DWidget *parent = nullptr);
    ~OfflineUpdateWidget();

    void setOfflineUpdateFile(QString filepath);

private:
    // 初始化界面
    void initUI();

public Q_SLOTS:
    void acceptImportFiles();

private:
    OfflineUpdateModel *m_model;

    DSuggestButton *m_importButton;
};
