/*
 * Copyright (C) 2023 ~ 2024 UnionTech Software Technology Co., Ltd.
 *
 * Author:     caimengci <caimengci@uniontech.com>
 *
 * Maintainer: caimengci <caimengci@uniontech.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include <DDialog>
#include <DFrame>
#include <DProgressBar>
#include <DLabel>
#include <QTextEdit>
#include <DBlurEffectWidget>

#include <QKeyEvent>
#include <QTimer>

class OfflineUpdateModel;
DWIDGET_USE_NAMESPACE
class OfflineUpgradeDialog : public QWidget
{
    Q_OBJECT

public:
    explicit OfflineUpgradeDialog(OfflineUpdateModel *model, QWidget *parent = nullptr);
    virtual ~OfflineUpgradeDialog() override;

    // 设置进度
    void setUpgradeProgress(int progress);

    // 设置安装信息
    void setUpgradeInfo(QString info);

private:
    // 初始化
    void initUI();
    void initData();

protected:
    bool event(QEvent *event) override;

private:
    OfflineUpdateModel *m_model;
    QProgressBar *m_progressBar;
    DLabel *m_progressLabel;
    DLabel *m_tipLabel;
    QTextEdit *m_textEdit;

    DBlurEffectWidget *m_blurEffect; // 透明背景
    int m_upgradeSec;

    QTimer *m_timer;
};
