/*
 * Copyright (C) 2020 ~ 2020 Deepin Technology Co., Ltd.
 *
 * Author:     caimengci <caimengci@uniontech.com>
 *
 * Maintainer: caimengci <caimengci@uniontech.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "systemupdatemodule.h"
#include "systemupdatewidget.h"
#include "systemupdatemodel.h"

#include <QModelIndex>
#include <QStandardItemModel>

SystemUpdateModule::SystemUpdateModule(FrameProxyInterface *frame, QObject *parent)
    : QObject(parent)
    , ModuleInterface(frame)
    , m_systemUpdateWidget(nullptr)
    , m_systemUpdateModel(nullptr)
{
}

SystemUpdateModule::~SystemUpdateModule()
{
    deactive();
}

void SystemUpdateModule::initialize()
{
}

void SystemUpdateModule::preInitialize()
{
}

const QString SystemUpdateModule::name() const
{
    return "systemupdate";
}

void SystemUpdateModule::active(int index)
{
    Q_UNUSED(index)

    if (!m_systemUpdateModel) {
        m_systemUpdateModel = new SystemUpdateModel(this);
    }
    m_systemUpdateWidget = new SystemUpdateWidget(m_systemUpdateModel);
    m_systemUpdateWidget->show();

    m_frameProxy->pushWidget(this, m_systemUpdateWidget);
}

void SystemUpdateModule::deactive()
{
    if (nullptr != m_systemUpdateWidget) {
        m_systemUpdateWidget->deleteLater();
        m_systemUpdateWidget = nullptr;
    }
}
